#pragma once
#include <set>
#include "atlwin.h"

extern std::set<HWND> _hDlgList;

template <class T, class TBase = CWindow>
class ATL_NO_VTABLE CModelessDialogImpl : public CDialogImpl<T, TBase>
{
public:
	HWND Create(HWND hWndParent, LPARAM dwInitParam = NULL)
	{
		HWND hWnd = CDialogImpl<T>::Create(hWndParent, dwInitParam);

		if(hWnd)
		{
			_hDlgList.insert(hWnd);
		}

		return hWnd;
	}

	BOOL DestroyWindow()
	{
		_hDlgList.erase(m_hWnd);
		return CDialogImpl<T>::DestroyWindow();
	}
};
