// aboutdlg.h : interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <memory>
#include "RawDoc.h"
#include "ModelessDialog.h"

#define BEGIN_MSG_MAP_EX(theClass) \
public: \
    __override BOOL ProcessWindowMessage(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT& lResult, DWORD dwMsgMapID = 0) \
	{ \
		BOOL bHandled = TRUE; \
		(hWnd); \
		(uMsg); \
		(wParam); \
		(lParam); \
		(lResult); \
		(bHandled);

#define BEGIN_MSG_MAP_END_PRELUDE() \
		switch(dwMsgMapID) \
		{ \
		case 0:

#define HSCROLL_HANDLER(ctl, func) \
	if(uMsg == WM_HSCROLL && (HWND)lParam == ctl) \
	{ \
		bHandled = TRUE; \
		lResult = func(HIWORD(wParam), LOWORD(wParam), (HWND)lParam, bHandled); \
		if(bHandled) \
			return TRUE; \
	}

class CParamDlg : public CModelessDialogImpl<CParamDlg>
{
protected:
	HWND m_hWndView;
	std::shared_ptr<CRawDoc> m_pDoc;
	bool m_refreshing;

	void refreshUpDown(int spinid, int textid, unsigned int minint, unsigned int maxint);
	void refreshTrackbar(int trackid, unsigned int value, unsigned short mshort);
	void refreshTrackbars();
	void refreshOrigs();
	struct order getRGBAOrder() const;
	void storeAndNotify();

public:
	enum { IDD = IDD_PARAMBOX };

	void setViewAndDoc(HWND hWndView, std::shared_ptr<CRawDoc> pDoc);

	BEGIN_MSG_MAP_EX(CParamDlg)
		// FIXME: ugly!!
		HWND wndWidthSlider = GetDlgItem(IDC_WIDTHSLIDER);
		HWND wndHeightSlider = GetDlgItem(IDC_HEIGHTSLIDER);
		BEGIN_MSG_MAP_END_PRELUDE()

		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		COMMAND_HANDLER(IDC_OFFSET, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_WIDTH, EN_CHANGE, OnChanged)
		HSCROLL_HANDLER(wndWidthSlider, OnWidthHeightSliderChanged)
		COMMAND_HANDLER(IDC_HEIGHT, EN_CHANGE, OnChanged)
		HSCROLL_HANDLER(wndHeightSlider, OnWidthHeightSliderChanged)
		COMMAND_HANDLER(IDC_INVERTY, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_BPP, CBN_SELCHANGE, OnChanged)
		COMMAND_HANDLER(IDC_RGB565, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_RGB555, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_RGBA5551, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_RGBA4444, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_RGBAORIG, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_RGBAORIGR, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_RGBAORIGG, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_RGBAORIGB, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_RGBAORIGA, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_ORDERRGBA, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_ORDERBGRA, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_ORDERORIG, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_ORDERORIGR, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_ORDERORIGG, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_ORDERORIGB, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_ORDERORIGA, EN_CHANGE, OnChanged)
		COMMAND_HANDLER(IDC_ENDIANESS, BN_CLICKED, OnChanged)
		COMMAND_HANDLER(IDC_LINEPAD, EN_CHANGE, OnChanged)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);

	LRESULT OnChanged(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnWidthHeightSliderChanged(WORD /*wPosition*/, WORD /*wCode*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};
