#include "stdafx.h"
#include "RawDoc.h"

#include <math.h>

CRawDoc::CRawDoc(HANDLE hFile) : m_field16(5, 6, 5, 0), m_order(0, 8, 16, 24)
{
	m_hFile = hFile;

	m_offset = 0;

	// Guessing width/height by filesize assuming aspect ratio is 4:3, but limit its size because big size is too heavy.
	LARGE_INTEGER li;
	GetFileSizeEx(hFile, &li);
	m_width = min((int)sqrt((double)li.QuadPart / (4*3)) * 4, 640);
	m_height = min((int)sqrt((double)li.QuadPart / (4*3)) * 3, 512);

	m_inverty = false;
	m_bpp = BPP_8;
	// field, order is already set.
	m_endianess = false;
	m_linepad = 0;
}


CRawDoc::~CRawDoc(void)
{
	CloseHandle(m_hFile);
}

BOOL CRawDoc::filesize(PLARGE_INTEGER pli) const
{
	return GetFileSizeEx(m_hFile, pli);
}
