#pragma once

// note: order is linked to ParamDlg's ComboBox.
enum BPP
{
	BPP_1 = 0,
	BPP_4,
	BPP_8,
	BPP_16,
	BPP_24,
	BPP_32,
};

struct field16
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;

	field16(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa)
	{
		set(ar, ag, ab, aa);
	}

	void set(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa)
	{
		r = ar;
		g = ag;
		b = ab;
		a = aa;
	}

	bool equals(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa) const
	{
		return r == ar && g == ag && b == ab && a == aa;
	}
};

struct order
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;

	order(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa)
	{
		set(ar, ag, ab, aa);
	}

	void set(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa)
	{
		r = ar;
		g = ag;
		b = ab;
		a = aa;
	}

	void set(struct order &other)
	{
		r = other.r;
		g = other.g;
		b = other.b;
		a = other.a;
	}

	bool equals(unsigned char ar, unsigned char ag, unsigned char ab, unsigned char aa) const
	{
		return r == ar && g == ag && b == ab && a == aa;
	}

	bool equals(struct order &other) const
	{
		return r == other.r && g == other.g && b == other.b && a == other.a;
	}

	struct order bgra() const
	{
		return struct order(b, g, r, a);
	}
};

class CRawDoc
{
protected:
	HANDLE m_hFile;

public:
	off_t m_offset;
	unsigned int m_width;
	unsigned int m_height;
	bool m_inverty;
	enum BPP m_bpp;
	struct field16 m_field16;
	struct order m_order;
	bool m_endianess;
	unsigned int m_linepad;

public:
	explicit CRawDoc(HANDLE hFile);
	~CRawDoc(void);

	BOOL filesize(PLARGE_INTEGER pli) const;
	HANDLE getFileHandle() const { return m_hFile; }
};

