// rawviewView.h : interface of the CRawviewView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <memory>
#include "RawDoc.h"
#include "ParamDlg.h"

class CRawviewView : public CScrollWindowImpl<CRawviewView>
{
protected:
	std::shared_ptr<CRawDoc> m_pDoc;
	CParamDlg m_paramDlg; // FIXME: param dlg handling in view??
	CDC m_hCacheDC;

	void fillbits(unsigned char* pbits) const;
	void updateCache(CDCHandle dc);

public:
	DECLARE_WND_CLASS(NULL)

	BOOL PreTranslateMessage(MSG* pMsg);

	void DoPaint(CDCHandle dc);

	void setDocument(std::shared_ptr<CRawDoc> pDoc);

	BEGIN_MSG_MAP(CRawviewView)
		MESSAGE_HANDLER(WM_APP + 0, OnParamDlgChanged)
		CHAIN_MSG_MAP(CScrollWindowImpl<CRawviewView>)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnParamDlgChanged(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
};
